
/*
 *	
 *  Copyright 2002 Erik Ljungstrm (erik.ljungstrom@metalab.unc.edu)
 *					
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.     This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.     
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 */
#include "bmi.h"

int
main (int argc, char *argv[])
{

	signal (SIGINT, signal_handler);

	bool console = false;

	std::string ui = "gui";

	if (argc != 1)
	{
		std::string tmpArgs (argv[1]);
		std::string * args = new std::string (in_Str2Low (tmpArgs));
		if ((*args == "--help") || (*args == "-h"))
			usage (PACKAGE);

		else if (*args == "--author")
		{
			std::cout <<
				"Written and maintained by Erik Ljungstrm (erik.ljungstrom@metalab.unc.edu)"
				<< std::endl;
			exit (EXIT_SUCCESS);
		}
		else if (*args == "--console")
		{
			ui = "console";
			console = true;
		}
		else if (*args == "--version")
		{
			std::cout << PACKAGE << VERSION << std::endl;
			exit (EXIT_SUCCESS);
		}

		else
		{
			std::cout << "Try bmi --help, or simply bmi." << std::
				endl;
			exit (EXIT_SUCCESS);
		}
		delete args;
	}

	char *path = getenv ("HOME"), *logname = getenv ("LOGNAME");


	std::string bmiDir = path, realpath, namn =
		logname, firstLength, lengthFile = path, loggie;
	std::string maxMin = path, sex = path, sexStore;

	double length, weight, BMI, BMIShort = 0, maxBmi = 0, minBmi = 0;
	weight = 1;
	int turn = 0;

	if (path == NULL || logname == NULL)
	{
		std::cout <<
			"You have some environment variables lacking. Try exporting HOME and LOGNAME, and try again."
			<< std::endl;
		leave (error, ui);
	}
	else
		realpath = path;

	bmiDir += "/.bmi";
	realpath += "/.bmi/results";
	lengthFile += "/.bmi/length";
	maxMin += "/.bmi/maxmin";
	sex += "/.bmi/sex";


	std::ifstream firstt (sex.c_str (), std::ios::binary);
	if (!firstt)
	{
		bool loopLength = false;
		std::string tempLength;
		do
		{
			std::cout << std::endl <<
				"Since this is the first time you run BMI, I'd like to know how tall you are; in the format m.cm: ";
			std::getline (std::cin, tempLength);
			if (!lookUp (tempLength))
				loopLength = true;
			else
				loopLength = false;
		}
		while (loopLength);
		length = atof (tempLength.c_str ());
		if (length > 3)
			length /= 10;
		mkdir (bmiDir.c_str (), 0700);
		std::ofstream tall (lengthFile.c_str (), std::ios::app);
		tall << length;
		tall.close ();

		bool tempLoop = true;
		std::string userSexUse;
		do
		{
			std::cout << std::
				endl << "Are you a male or female (m/f); ";
			std::cin >> userSexUse;
			if ((userSexUse != "m") && (userSexUse != "f"))
				std::cerr <<
					"You must give f (female) or m (male) here."
					<< std::endl;
			else
				tempLoop = false;

		}
		while (tempLoop);

		std::ofstream outSex (sex.c_str (), std::ios::binary);
		outSex << userSexUse;
		outSex.close ();

		std::ofstream maxx (maxMin.c_str (), std::ios::app);
		maxx << 0 << std::endl << 1000;
		maxx.close ();
	}

	std::ifstream ReadFile (lengthFile.c_str (), std::ios::binary);
	getline (ReadFile, loggie);
	std::istringstream in (loggie);
	in >> length;
	ReadFile.close ();
	loggie = "";
	std::ifstream readMaxMin (maxMin.c_str (), std::ios::binary);
	while (getline (readMaxMin, loggie))
	{
		if (turn == 0)
		{
			maxBmi = atof (loggie.c_str ());
			turn++;
		}
		if (turn == 1)
			minBmi = atof (loggie.c_str ());
	}
	readMaxMin.close ();

	loggie = "";
	std::ifstream readSex (sex.c_str (), std::ios::binary);
	while (getline (readSex, loggie))
		sexStore = loggie;
	readSex.close ();

	do
	{
		switch (meny (ui))
		{

		case 1:
		{
			bool digits = true;
			do
			{
				char buf2[2048] = "";
				digits = true;
				bool noleave = false;
				if (console)
				{
					do
					{
						char *cmd2 =
							"dialog --no-cancel --title \"BMI-1.3.0\" --stdout --inputbox \"How much do you weigh?\" 0 0";
						FILE *ptr2 =
							popen (cmd2, "r");
						if (!ptr2 || ptr2 == NULL)
						{
							perror ("popen");
							std::cerr <<
								"Something went wrong while attempting to run \"dialog\". Please see to it that this program is installed\n and try again."
								<< std::endl;
							leave (error, ui);
						}
						fgets (buf2, BUFSIZ, ptr2);
						std::string lookVal = buf2;
						if (!lookUp (lookVal))
							noleave = true;
						else
							noleave = false;
						if (lookVal[0] == '0') //If user inputs 0, do not break loop
							noleave = true;
						if (lookVal.size() == 1 || lookVal.size() == 0) 
							noleave = true;
						pclose (ptr2);
					}
					while (noleave);
				}
				else // if GUI (Xdialog)
				{
					do
					{
						char *cmd2 =
							"Xdialog --no-cancel --no-close --title \"BMI-1.3.0\" --stdout --inputbox \"How much do you weigh?\" 0 0";
						FILE *ptr2 =
							popen (cmd2, "r");
						if (!ptr2 || &ptr2 == NULL)
						{
							perror ("popen");
							std::cerr <<
								"Something went wrong while attempting to run \"dialog\". Please see to it that this program is installed\n and try again."
								<< std::endl;
							leave (error, ui);
						};
						fgets (buf2, BUFSIZ, ptr2);
						std::string lookVal = buf2;
						if (!lookUp (lookVal))
							noleave = true;
						else
							noleave = false;
						if (lookVal[0] == '0') //If user inputs 0, do not break loop
							noleave = true;
						if (lookVal.size() == 1 || lookVal.size() == 0) 
							noleave = true;
						
						pclose (ptr2);
					}
					while (noleave);
				}


				for (unsigned int j = 0;
				     j < strlen (buf2) - 1; j++)
					if ((!isdigit (buf2[j])) 
					    && (buf2[j] != '.'))
						digits = false;
				if (digits == true)
					weight = atof (buf2);


			}
			while (!digits);

			BMI = weight / pow (length, 2);
			if (BMI > maxBmi)
				maxBmi = BMI;

			if (BMI < minBmi)
				minBmi = BMI;
			
			//if (BMI <= 0){
				
				
			remove (maxMin.c_str ());
			std::ofstream toMaxMin (maxMin.c_str (),
						std::ios::binary);
			toMaxMin << maxBmi << std::endl << minBmi;
			toMaxMin.close ();

			std::ofstream toRes (realpath.c_str (),
					     std::ios::app);
			time_t timer;
			struct tm *tblock;
			timer = time (NULL);
			tblock = localtime (&timer);
			toRes << asctime (tblock);
			toRes << namn << " had the BMI value of " << std::
				setprecision (4) << BMI << std::endl;
			toRes.close ();

			std::ostringstream showRes;
			if (console)
				showRes <<
					"dialog --title \"BMI-1.3.0\" --title \"Your BMI is\" --msgbox "
					<< std::
					setprecision (4) << BMI << " 0 0";
			else
				showRes <<
					"Xdialog --title \"BMI-1.3.0\" --title \"Your BMI is\" --msgbox "
					<< std::
					setprecision (4) << BMI << " 0 0";
			system (showRes.str ().c_str ());
			BMIShort = floor (BMI * 100.0 + .5) / 100.0;
			if (sexStore == "m")
			{

				if (BMI > 45.4)
				{
					if (console)
						system ("dialog --title \"BMI-1.3.0\" --msgbox \"Morbid obesity. You will for sure suffer from health problems at higher age.\" 0 0");
					else
						system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"Morbid obesity. You will for sure suffer from health problems at higher age.\" 0 0");
				}
				if (BMI < 20.7)
				{
					if (console)
						system ("dialog --title \"BMI-1.3.0\" --msgbox \"You are underweight! Consider seeing a dietitian You may have some health problems at greater age.\" 0 0");
					else
						system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"You are underweight! Consider seeing a dietitian! You may have some health problems at greater age.\" 0 0");
				}

				for (double i = 31.1; i < 45.5; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("ddialog --title \"BMI-1.3.0\" --msgbox \"Your fatness is _very_ unhealthy. Consider searching help.\" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"Your fatness is _very_ unhealthy. Consider searching help.\" 0 0");
					}
				}

				for (double i = 27.8; i < 31.1; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"Your weight is above what's consider healthy. Consider a diet.\" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"Your weight is above what's consider healthy. Consider a diet.\" 0 0");
					}
				}

				for (double i = 26.4; i < 27.8; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"You are marginally overweight. There is some risk for health problems in the future. \" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"You are marginally overweight. There is some risk for health problems in the future. \" 0 0");
					}
				}
				for (double i = 20.7; i < 26.4; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"Ideal weight! The health risk is minmal! Keep it up! \" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"Ideal weight! The health risk is minmal! Keep it up! \" 0 0");
					}
				}

			}


			else if (sexStore == "f")
			{
				for (double i = 32.3; i < 44.8; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"You are very overweight, do concider seeing a dietitian.\" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"You are very overweight, do concider seeing a dietitian.\" 0 0");
					}
				}

				for (double i = 27.3; i < 32.2; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"You are overweight, consider going on a diet. Moderate health risk \" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"You are overweight, consider going on a diet. Moderate health risk \" 0 0");
					}
				}

				for (double i = 25.8; i < 27.3; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"Marginally overweight. There is some risk for health problems in the future. \" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"Marginally overweight. There is some risk for health problems in the future. \" 0 0");
					}
				}

				for (double i = 19.1; i < 25.8; i += 0.01)
				{
					if (fabs (BMIShort - i) < 1e-3)
					{
						if (console)
							system ("dialog --title \"BMI-1.3.0\" --msgbox \"This is your ideal weight. Keep it up! \" 0 0");
						else
							system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"This is your ideal weight. Keep it up! \" 0 0");
					}
				}

				if (BMI > 44.8)
				{
					if (console)
						system ("dialog --title \"BMI-1.3.0\" --msgbox \"Morbid obesity. You will for sure suffer from healt problems at higher age.\" 0 0");
					else
						system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"Morbid obesity. You will for sure suffer from healt problems at higher age.\" 0 0");
				}
				if (BMI < 19.1)
				{
					if (console)
						system ("dialog --title \"BMI-1.3.0\" --msgbox \"You are underweight! Consider seeing a dietitian ! You may have some health problems at greater age.\" 0 0");
					else
						system ("Xdialog --title \"BMI-1.3.0\" --msgbox \"You are underweight! Consider seeing a dietitian! You may have some health problems at greater age.\" 0 0");
				}
			}

			break;
		}

		case 2:
		{
			if (console)
			{
				if (sexStore == "m")
					system ("dialog --title \"BMI-1.3.0\" --tailbox /usr/share/bmi/bmi_scale.m 0 0");
				if (sexStore == "f")
					system ("dialog --title \"BMI-1.3.0\" --tailbox /usr/share/bmi/bmi_scale.f 0 0");
			}
			else
			{
				if (sexStore == "m")
					system ("Xdialog --title \"BMI-1.3.0\" --tailbox /usr/share/bmi/bmi_scale.m 0 0");
				if (sexStore == "f")
					system ("Xdialog --title \"BMI-1.3.0\" --tailbox /usr/share/bmi/bmi_scale.f 0 0");
			}
			break;

		}

		case 3:
		{

			std::ostringstream lengthStream;

			if (console)
				lengthStream <<
					"dialog --title \"BMI-1.3.0\" --stdout --inputbox \"How tall are you now?\" 0 0 m.cm > "
					<< lengthFile;
			else
				lengthStream <<
					"Xdialog --title \"BMI-1.3.0\" --stdout --inputbox \"How tall are you now?\" 0 0 m.cm > "
					<< lengthFile;
			system (lengthStream.str ().c_str ());

			std::string loggie2;
			std::ifstream ReadFile2 (lengthFile.c_str (),
						 std::ios::binary);
			getline (ReadFile2, loggie2);
			std::istringstream in2 (loggie2);
			in2 >> length;

			break;
		}

		case 4:
		{
			FILE *tf = fopen (realpath.c_str (), "r");
			if (!tf)
			{
				if (console)
					system ("dialog  --title \"BMI-1.3.0\" --msgbox \"The file containing this information does not exist. Creating one...\" 0 0");
				else
					system ("Xdialog  --title \"BMI-1.3.0\" --msgbox \"The file containing this information does not exist. Creating one...\" 0 0");

				std::ofstream result (realpath.c_str (),
						      std::ios::app);
				result << "";
				result.close ();
			}
			else
			{

				std::ostringstream uglyOne;
				if (console)
					uglyOne <<
						"dialog --title \"" << PACKAGE
						<< VERSION "\" --textbox " <<
						realpath << " 0 0";
				else
					uglyOne <<
						"Xdialog --title \"" <<
						PACKAGE << VERSION <<
						"\" --textbox " << realpath <<
						" 0 0";

				system (uglyOne.str ().c_str ());
			}
			break;

		}

		case 5:
		{
			remove (maxMin.c_str ());
			std::ofstream recreateMaxx (maxMin.c_str (),
						    std::ios::app);
			recreateMaxx << 0 << std::endl << 1000;
			recreateMaxx.close ();

			remove (realpath.c_str ());
			std::ofstream recreateRealpath (realpath.c_str (),
							std::ios::app);
			recreateRealpath << " " << std::endl;
			recreateRealpath.close ();
			break;
		}

		case 6:
		{
			std::ostringstream getMinMax;
			if (console)
				getMinMax <<
					"dialog --title \"" << PACKAGE <<
					VERSION <<
					"\" --msgbox \"Max bmi is: " << maxBmi
					<< std::
					endl << "Min bmi is: " << minBmi <<
					"\" 0 0";
			else
				getMinMax <<
					"Xdialog --title \"" << PACKAGE <<
					VERSION "\" --msgbox \"Max bmi is: "
					<< maxBmi << std::
					endl << "Min bmi is: " << minBmi <<
					"\" 0 0";
			system (getMinMax.str ().c_str ());
			break;
		}

		case 7:
		{
			std::ostringstream printOut, dispPrint;
			printOut << "cat " << realpath << " > /dev/lp0";
			system (printOut.str ().c_str ());
			if (console)
				dispPrint <<
					"dialog --title \"" << PACKAGE <<
					VERSION <<
					"\" --sleep 2 --infobox \"Printing from \""
					<< realpath << " 3 45";
			else
				dispPrint <<
					"Xdialog --title \"" << PACKAGE <<
					VERSION <<
					"\" --sleep 2 --infobox \"Printing from \""
					<< realpath << " 3 45";

			system (dispPrint.str ().c_str ());
			break;
		}

		case 8:
		{
			double shouldWeight = 22.5 * pow (length, 2);
			std::ostringstream showShould;
			if (console)
				showShould <<
					"dialog  --title \"" << PACKAGE <<
					VERSION <<
					"\" --msgbox \"For your length, you should weigh \""
					<< shouldWeight << " 0 0";
			else
				showShould <<
					"Xdialog  --title \"" << PACKAGE <<
					VERSION <<
					"\" --msgbox \"For your length, you should weigh \""
					<< shouldWeight << " 0 0";

			system (showShould.str ().c_str ());
			break;
		}
		case 9:
		{
			leave (clean, ui);
			break;
		}

		default:
		{
			leave (clean, ui);
			break;
		}
		}

	}
	while (1);
	return (clean);
}
